// Per-pixel lighting shader for PBA Challenge
// Copyright 2013 Concrete Software. All rights reserved.

uniform mat4 cs_ModelViewProjectionMatrix;
// Model view matrix without projection multiplied in. Needed for specular lighting.
uniform mat4 cs_ModelViewMatrix;

#ifdef BUMPMAP
attribute vec3 pba_Bitangent;
attribute vec3 pba_Tangent;
varying lowp vec3 var_Bitangent;
varying lowp vec3 var_Tangent;
#else
uniform mat3 cs_NormalMatrix;
#endif

attribute vec4 cs_Vertex;
attribute vec3 cs_Normal;
attribute vec2 cs_MultiTexCoord0;

varying mediump vec2 var_TexCoord;
varying mediump vec3 var_Normal;
varying mediump vec3 var_TransformedVertex;

void main()
{
#ifdef BUMPMAP
	var_Normal = cs_Normal;
    var_Bitangent = pba_Bitangent;
    var_Tangent = pba_Tangent;
#else
	var_Normal = cs_NormalMatrix * cs_Normal;
#endif
	var_TexCoord = cs_MultiTexCoord0.xy;
    var_TransformedVertex = (cs_ModelViewMatrix * cs_Vertex).xyz;
	gl_Position = cs_ModelViewProjectionMatrix * cs_Vertex;
}